# CellTracking.py
# By MW, Jun 2013
# GPLv3+
#
# Module managing the menu in the Player

import gtk, logging

class Menu :
    def __init__(self, player) :
        """Receives a player instance"""
        self.player = player
    def get_menu(self) :
        self.menubar = gtk.MenuBar()

        # Menu file
        menu_file = gtk.Menu()
        menu_file_m = gtk.MenuItem("File")
        menu_file_m.set_submenu(menu_file)
        menu_exit = gtk.MenuItem("Exit")
        menu_exit.connect("activate", self.player.quit)
        menu_file.append(menu_exit)

        # Menu View
        menu_view_m = gtk.MenuItem('View')
        self.menu_view = gtk.Menu()
        menu_view_m.set_submenu(self.menu_view)
        menu_scalew = gtk.MenuItem("Scale window to video")
        self.menu_view.append(menu_scalew)
        
        menu_scale = gtk.Menu()
        menu_scalew.set_submenu(menu_scale)

        menu_scalew50 = gtk.MenuItem("50%")
        menu_scalew100 = gtk.MenuItem("100%")
        menu_scalew200 = gtk.MenuItem("200%")
        menu_scalew400 = gtk.MenuItem("400%")

        menu_scale.append(menu_scalew50)
        menu_scale.append(menu_scalew100)
        menu_scale.append(menu_scalew200)
        menu_scale.append(menu_scalew400)
        
        menu_scalew50.connect('activate', self.scale_viewer, 0.5)
        menu_scalew100.connect('activate', self.scale_viewer, 1)
        menu_scalew200.connect('activate', self.scale_viewer, 2)
        menu_scalew400.connect('activate', self.scale_viewer, 4)


        # Menu Cells
        menu_cells = gtk.Menu()
        menu_cells_m = gtk.MenuItem("Cells")
        menu_cells_m.set_submenu(menu_cells)
        menu_hideshow_c = gtk.MenuItem("Show/Hide cells")
        menu_hideshow_p = gtk.MenuItem("Show/Hide cells panel")
        menu_hideshow_c.connect("activate", self.tmp)
        menu_hideshow_p.connect("activate", self.show_hide_cells_panel)
        menu_cells.append(menu_hideshow_c)
        menu_cells.append(menu_hideshow_p)

        self.menubar.append(menu_file_m)
        self.menubar.append(menu_view_m)
        self.menubar.append(menu_cells_m)
        self.menubar.show_all()
        return self.menubar

    def scale_viewer(self, w, scale) :
        self.player.viewer.set_scale(scale)
    def show_hide_cells_panel(self, w) :
        self.player.cells.hide_show_panel()
    def tmp(self, w) :
        logging.warning("Hide/Show cells not implemented yet")
    def add_button(self, inst) :
        b = inst.get_button()
        b.show()
        self.menu_view.append(b)
