# Pyhton script that serves as an example for the CellTracking features.
# Main programmable interface to CellTracking. This script is devoted to all the testing.
# by MW, Jun 2013, GPLv3+


import CellTracking  # Import all the cool stuff :)

# ===== Functions
def new_cell(player, coord, name,already_init=False) :
    """Function that create a new cell"""
    c = player.cells.new_cell_panel.new_cell('pol') # Create a gtk cell object
    c.close() # Init the cell
    c.cell.set_name(name)
    c.cell.cell_pol.add_timepoint(0, coord) # Add some points into the cell
    c.cell.cell_ref.add_timepoint(0, coord) # Add some points into the cell
    c.visible = True
    if not already_init :
        player.cells.hide_show_panel() # Show the cells panel (required before adding a new cell)
        p.cells.hide_show_panel() # Hide it right after this

    p.cells.add_cell(name, c)
    

# ===== Main

img_paths = ["./demo/1.png", "./demo/2.png", "./demo/3.png", "./demo/4.png", "./demo/5.png", "./demo/6.png", "./demo/7.png", "./demo/8.png", "./demo/9.png", "./demo/10.png", "./demo/11.png", "./demo/12.png", "./demo/13.png", "./demo/14.png", "./demo/15.png"] # Lets define some data!
#img_paths = ['./demo/tifimage.tif']

m = CellTracking.Movies.new_movie() # Initialize a new movie

ch = m.Channels.new_channel("test") # Create a new channel called test

ch.Loader.load(img_paths, "list_files") # Load files into the channel

#cell = m.Cells.new_cell('baboucell') # Creating a cell inside tha movie

s = CellTracking.States.new_state(m) # Create a state to initialize a player

p = CellTracking.Players.new_player(s) # Initialize a player related to the state instance

c1 = new_cell(p, [(10,10), (200,10), (10,200)], 'bbc1') # Add a new cell
#c2 = new_cell(p, [(400,400), (400,20), (200,400)], 'bbc2') # Add a new cell
#p.cells.hide_show_panel() # Show cells panel


#p.contrast.hide_show_panel() # Show the contrast panel


#p.cells.hide_show_new_cell_panel('pol') # Create a polygon cell (show the panel)

p.start() # Start the player (starts gtk.main())
